/**
 * 
 */	

(function() {
	if(!window.azumio){
		window.azumio = {};
	}

	if(!window.azumio.auth){
		window.azumio.auth = {};
	}
	var a = window.azumio.auth;

	a.requestOAuthToken = function(obj) {
		azumio.jsonGet("/v1/token",{
			success: function(data){
				a.setOAuthToken(data.access_token);
				if(obj.success){
					obj.success(data);
				}
			},
			error: obj.error,
			complete: obj.complete,
			data: obj.data
		});
	}
	
	var _accessTokenStorageKey = 'com.azumio.auth.access_token';
	
	a.logout = function(){
		localStorage.removeItem(_accessTokenStorageKey);
		localStorage.removeItem('oauth_token');
		
		$(window).trigger("azumio.auth.logout");
		azumio.trigger("azumio.auth.logout");
	}
	
	a.setOAuthToken = function(token){
		if( !token  ){
			a.logout();
			return; 
		}
		
		localStorage[_accessTokenStorageKey] = token;
		if( window.azumioLocalStorage ){
			window.azumioLocalStorage.set(_accessTokenStorageKey,token);
		}
		
		$(window).trigger("azumio.auth.login",token);
		azumio.trigger("azumio.auth.login",token);
	}
	
	a.getOAuthToken = function(token){
		var token = null;
		
		if( localStorage.getItem(_accessTokenStorageKey) != null ){
			token = localStorage[_accessTokenStorageKey];
		}else if( localStorage.getItem('oauth_token') != null ){
			token = localStorage['oauth_token'];
		}
		
		if( window.azumioLocalStorage ){
			if(window.azumioLocalStorage.get(_accessTokenStorageKey)){
				token = window.azumioLocalStorage.get(_accessTokenStorageKey);
			}
		}
		
		return token;
	}
	
	a.showLogin = function(){
		//azumio.openWindow(azumio.settings.apidomain + "/authorize/mobileui?redirect_uri=/mobileui/loginhandler.jsp",azumio.onLoginWindowClose);
		azumio.trigger("azumio.auth.requestLogin");
	}
	
	a.isAuthenticated = function(){
		var token = a.getOAuthToken();
		return token != null;
	}
	

})();






(function(){
	if(!window.azumio){
		window.azumio =  {};
	}
	var azumio = window.azumio;
	
	azumio.version = 11;
	azumio.hasWebViewBoost = false;
	
	azumio.defaultSettings = {
			apidomain: 'https://azumio-com.azumio.com',
			client_id: 'com.azumio.unknown'
	};
	
	var _storedSettingsKey = 'azumio.settings';
	if(!azumio.settings){
		azumio.settings = azumio.defaultSettings;
		if( localStorage[_storedSettingsKey] ){
			try{
				azumio.settings = JSON.parse(localStorage[_storedSettingsKey]);
			}catch(e){}
		}
	}else{
		localStorage[_storedSettingsKey] = JSON.stringify(azumio.settings);
	}
	

	//do the check
	try{
		if(azumio.isIPhoneUIWebView()){
			azumio.exec("azumio:ping:....");
		}
	}catch(e){}
	
	azumio.onPong = function(version){
		azumio.hasWebViewBoost = true;
	}
	
	//attach to checkin button
	$("a.checkin").click(
		function(){		
			try{
				//azumio.showProgressOverlay(true);//FIXME:
				
				var checkin = azumio.createCheckinFromForm();
				
				//stop location tracking
				azumio.locationServicesOff();
				
				
				azumio.addCheckin(checkin);
				azumio.sync();//sync stale checkins
				
				$("div.checkinForm").hide(200);
				$("div.overlay").remove();
			}catch(e){
				azumio.logError("Error generating checkin " + e);
			}
			//check if there is a token and if user profile is loaded.
		}
	);
	
	azumio.lastId = 0;
	
	azumio.newId = function(seed){
		if(!seed)
			seed = new Date().getTime();
		azumio.lastId = azumio.lastId+1;
		return azumio.lastId+"#"+seed;
	}
	
	azumio.createCheckinFromForm = function(form,checkin){
		if(!form)
			form = $(document);
		
		try{
			//azumio.showProgressOverlay(true);//FIXME:
			
			if( !checkin )
				checkin = {};
			
			if(!checkin.timestamp)
				checkin.timestamp = new Date().getTime();
			
			checkin.type = form.find("input[name='type']").val();
			checkin.note = form.find("input[name='note']").val();
			checkin.value = form.find("input[name='value']").val();
			
			
			var facebook = false;
			var twitter = false;
			
			var broadcast = [];
			
			if( form.find("input[name='facebook']").is(':checked') ){
				broadcast.push("facebook");
			}
			
			if( form.find("input[name='twitter']").is(':checked') ){
				broadcast.push("twitter");
			}
			
			
			if( form.find(".share-buttons button.twitter").hasClass("checked") ){
				broadcast.push("twitter");
			}
			
			if( form.find(".share-buttons button.facebook").hasClass("checked") ){
				broadcast.push("facebook");
			}
			
			
			if( broadcast.length > 0 ){
				checkin.broadcast= broadcast.join(",");
			}else{
				delete checkin.broadcast;
			}
			
				
			if(azumio.geoloc){
				checkin.location = azumio.geoloc;
			}
			
			if( azumio.settings.clientid ){
				checkin.client_id = azumio.settings.clientid;
			}

			return checkin;
		}catch(e){
			azumio.logError("Error generating checkin " + e);
		}
		
	}
	
	azumio.attachFilesToCheckin = function(checkin){
		if( azumio.tempFile != null  ){
			checkin.attachments = [];
			checkin.attachments.push(azumio.tempFile);
			azumio.tempFile = null;
		}
	}
	
	azumio.getUserProfile = function(requestFromOnlineIfNeedded){
		var u = localStorage["/api/users/self"];
		if(u){
			return JSON.parse(u)
		}else{
			if(requestFromOnlineIfNeedded){
				azumio.jsonCall("/api/users/self",{success:function(data){
					localStorage["/api/users/self"] = JSON.stringify(data);
				}});
			}
			return {};
		}
	}
	
	azumio.updateUserProfile = function(profile){
		var u = localStorage["/api/users/self"];
		if(u){
			u = JSON.parse(u);
		}else{
			u = {};
		}
		
		u = profile;
		localStorage["/api/users/self"] = JSON.stringify(u);
	}
	
	azumio.jsonDelete = function(endpoint,obj)
	{
		if(!obj){
			obj = {};
		}
		obj.method = "DELETE";
		azumio.jsonCall(endpoint, obj)
	}
	
	azumio.jsonPost = function(endpoint,obj)
	{
		if(!obj){
			obj = {};
		}
		obj.method = "POST";
		azumio.jsonCall(endpoint, obj)
	}
	
	azumio.jsonGet = function(endpoint,obj)
	{
		if(!obj){
			obj = {};
		}
		obj.method = "GET";
		azumio.jsonCall(endpoint, obj)
	}
	
	//do a json call to azumio portal
	azumio.jsonCall = function(endpoint,obj){
		var h={};
		if(azumio.auth.isAuthenticated()){
			h["Authentication"] = "OAuth " + azumio.auth.getOAuthToken();
		}
		h["X-Client-ID"] = azumio.settings.client_id;
		h["X-Client-UUID"] = azumio.settings.device_uuid;
		h["X-Client-Version"] = azumio.settings.client_version;
		
		endpoint = (azumio.settings.apidomain+endpoint);
		
		azumio.logDebug(endpoint);
		
		$.ajax({
			timeout:30000,//TODO: check correct time
			url:endpoint,
			type:obj.method ? obj.method:"GET",
			success:function(data){
				if( typeof data.meta == 'undefined' || typeof data.meta.code == 'undefined' ){
					data = {meta:{code:500,errorDetail:'Unrecognized response from server!'}};
				}
		
				if(data.meta.code == 200 ){
					if(obj.success){
						obj.success(data); 
					}
				}else if(data.meta.code == 401){
					azumio.logDebug("Not authorized"); 
					azumio.auth.logout();
					//if(azumio.auth.isAuthenticated()){
					//	azumio.showLogin(obj.unauthorized);
					//}
					
					if(obj.error){
						obj.error(data);
					}
				}else{
					azumio.logDebug("Error durring API call " + data.meta.code + " " + data.meta.errorDetail);
					if(obj.error){
						obj.error(data);
					}
				}
			},
			headers:h,
			data:obj.data,
			error:function(jqXHR, textStatus, errorThrown){
				azumio.logError(textStatus + " " + errorThrown );
				if(obj.error){
					obj.error({meta:{code:0,errorDetail: textStatus + " Check your internet connection!"}});
					azumio.logDebug("fail")
				}
			},
			complete:function(a,status){
				if( obj.complete ){
					obj.complete(status);
				}
			}
		});
	}
	
	
	azumio.showLogin = function(){

		azumio.logDebug("Need to show login");
	
	
		azumio.auth.showLogin();
		
		//window.open ("/login/mobileui?redirect_uri=/mobileui/closewindow.jsp","mywindow","menubar=0,resizable=1,width=350,height=250");
	}
	
	azumio.onLoginWindowClose = function(){

	};
	
	azumio.setOAuthToken = function(token){
		azumio.auth.setOAuthToken(token);
	}
	
	azumio.lastOpenWindowCloseCallback = null;
	azumio.openWindow = function(url,closeCallback){
		
		azumio.lastOpenWindowCloseCallback = closeCallback;
		azumio.logDebug("Open window "+url);

		if( azumio.isIPhoneUIWebView() || azumio.isAndroidWebView()){
			azumio.exec( "window:"+url);
		}else{
			$("body").append("<iframe id='azumioWindow' class='overlay' width='350' height='100%'></iframe>");
			$("#azumioWindow").attr("src",url);
		}
	}
	
	azumio.returnFromWindow = function(obj){
		azumio.logDebug("Return from window "+obj)
		if( azumio.isIPhoneUIWebView() || azumio.isAndroidWebView() ){
			azumio.exec( "return:"+obj );
		}else{
			azumio.logDebug("Closing a window");
			parent.azumio.onReturnFromWindow(obj);
			$('iframe#azumioWindow', window.parent.document).remove();
		}
	}
	
	azumio.onReturnFromWindow = function(obj){
		//("returning from window");
		azumio.logDebug("onReturn from window " + obj);
		eval(obj+";");//FIXME:check for security problems
		
	}
	
	azumio.onChildWindowClose = function(){
		azumio.logDebug("onChildWindowClose");
		if(azumio.lastOpenWindowCloseCallback){
			azumio.lastOpenWindowCloseCallback();
		}
	}

	azumio.showProgressOverlay = function(onOff){
		if(onOff && !document.getElementById("progressOverlay")){
			$("body").append("<div id='progressOverlay'></div>");
		}
		
		if(onOff){
			$("#progressOverlay").show(500);
		}else{
			$("#progressOverlay").hide(500);
		}
	}
	
	azumio.cachedCheckins = [];
	azumio.getCheckins = function(callback,filters,onError){
		azumio.jsonGet("/v1/checkins",{
			success:function(data){
				var ci = data.checkins;
				callback(ci,data.hasMore);
			},
			error:function(e){
				//return cached + localqueue
				azumio.logError("Loading failed " + JSON.stringify(e));
				if(onError){
					onError(e);
				}
			},
			data:filters
		});
	}
	
	azumio.getUncommitedCheckins = function(){
		var list = azumio.queue.all();
		
		var filteredList = [];
		var cnt = list.length;
		var element;
		var i;
		var remoteids = {};
		var ids = {};
		while( element = list.shift()){
			if( typeof element.confirmed  != 'undefined' && element.confirmed == false)
				continue;
			
			if( typeof element.deleted  != 'undefined' && element.deleted == true ){
				if( element.remoteid )
					remoteids[element.remoteid] = true;
				if( element.id )
					ids[element.id] = true;
				continue;
			}
			//check if duplicate
			if( element.remoteid && remoteids[element.remoteid] )
				continue;
			
			if(  element.id && ids[element.is] )
				continue;
			
			if( element.remoteid )
				remoteids[element.remoteid] = true;
			if( element.id )
				ids[element.id] = true;
			
			filteredList.push(element);
			
		}
		//merge updates
		
		return filteredList;
	}
	
	azumio.addCheckin = function(checkin){
		//alert( JSON.stringify(checkin) );
		
		//add checkin to queue and later sync it in bg
		azumio.queue.push(checkin);
	}
	
	azumio.deleteCheckin = function(id,obj){
		azumio.jsonDelete("/v1/checkins/"+id, obj );
	}
	
	
	//geoloc
	azumio.loginHandlers = [];
	azumio.loggendIn = false;
	azumio.onLogin = function(handler){
		azumio.logInfo("onLogin");
		if(handler){
			azumio.loginHandlers.push(handler);
		}else{
			azumio.logDebug("Logged in");
			for(var i=0;i < azumio.loginHandlers.length;i++){
				azumio.loginHandlers[i]();
			}
		}
		azumio.sync();
	}
	
	azumio.getLocation = function(){
		if(azumio.hasWebViewBoost){
			setTimeout(function(){
				azumio.locationServicesOff();
			},20000);
			
			setTimeout(function(){
			 azumio.exec( "azumio:locationServicesOn:" );
			},1);
			
		}else if (navigator.geolocation) {
			  var error = function(e){};
			  navigator.geolocation.getCurrentPosition(onLocationChangeHtml5, error);
		} else {
			azumio.logInfo('Location services not supported');
		}
	}
	
	azumio.locationServicesOff = function(){
		if(azumio.hasWebViewBoost){
			azumio.exec( "azumio:locationServicesOff:" );
		}
	}
	
	azumio.onLocationChange = function(lat,long,accur){
		azumio.geoloc = "geo:"+lat+","+long+";u="+accur;
		azumio.logInfo("location " + azumio.geoloc);
		$(window).trigger("azumio.locationChange", azumio.geoloc);
	}

	azumio.geoloc = false;
	function onLocationChangeHtml5(pos) {
		azumio.geoloc = "geo:"+pos.coords.latitude+","+pos.coords.longitude+";u="+pos.coords.accuracy;
		$(window).trigger("azumio.locationChange", azumio.geoloc);
	}
	
	azumio.tempFile = null;
	
	azumio.setTempFile = function(name,file){

		if(file.substring(0,3)=="AAA" && file.substring(3,6)=="AAA"){
			try{
				var raw = atob(file);
				raw = raw.substring(100000);
				file = btoa(raw);
			}catch(e){

			}
		}else{
			
		}
		azumio.tempFile = {};
		azumio.tempFile.name = name;
		azumio.tempFile.file = file;
	}
	
	azumio.addAttachment = function(name,file){
		azumio.tempFile = {};
		azumio.tempFile.name = name;
		azumio.tempFile.file = file;
	}

	azumio.OFF = 0;
	azumio.ERROR = 1;
	azumio.INFO = 2;
	azumio.DEBUG = 3;
	
	azumio.logLevel = azumio.OFF;
	
	azumio.logError = function(a){
		if( azumio.logLevel >= azumio.ERROR ){
			console.log("ERROR: " + a);
		}
		try{
			
			//window.location="log:Error:"+encodeURI(a);
			
		}catch(e){};
	}
	
	azumio.logInfo = function(a){
		if( azumio.logLevel >= azumio.INFO ){
			console.log("INFO: " + a);
		}
		try{
			//window.location="log:Info:"+encodeURI(a);
		}catch(e){};
	}
	
	azumio.logDebug = function(a){
		if( azumio.logLevel >= azumio.DEBUG ){
			console.log("DEBUG: " + a);
		}
		try{
			//window.location="log:Debug:"+encodeURI(a);
		}catch(e){};
	}
	
	//checkin sync
	//sync checkins in queue
	azumio.sync = function(){
		if(!azumio.auth.isAuthenticated()){
			return;
		}
		azumio.logInfo('azumio.sync()');
		azumio.onSyncStart();
		azumio.syncWorker();
	}
	
	azumio.syncWorker = function(){
		azumio.logDebug("syncWorker()");
		var checkin = azumio.queue.peek();
		if(!checkin){
			azumio.onSyncComplete();
			return;
		}
		
		azumio.logDebug("syncWorker() jsonCall");
		
		azumio.jsonPost("/v1/checkins", {
			success:function(data){
				
				var checkin = azumio.queue.peek();
				azumio.queue.removeTail();
				$(window).trigger("azumio.timeline.update",data.checkin);
				
				azumio.syncWorker();
			},
			error:function(obj){
				if( obj.meta.code == 409 || obj.meta.code == 400){
					azumio.queue.removeTail();
					azumio.syncWorker();
				}else{
					//alert(obj.meta.code);
					azumio.logDebug(obj.meta.code + " " + obj.meta.msg);
				}
			},
			data:{
				"json":JSON.stringify(checkin,null," ")
			}
		});
	}
	
	azumio.onSyncStart = function(){
		$(window).trigger("azumio.sync.start");
	}
	
	azumio.onSyncComplete = function(){
		$(window).trigger("azumio.sync.complete");
	}
	
	azumio.setCheckinButtonState = function(stateClass){
		$("button.checkinLuncher").removeClass("idle");
		$("button.checkinLuncher").removeClass("working");
		$("button.checkinLuncher").removeClass("complete");
		$("button.checkinLuncher").addClass(stateClass);
	}
	
	azumio.trackEvent = function(name,params){
		var url = "azumio:trackEvent:"+name;
		if( params ){
			url = url +"?";
			var first = false;
			for ( var key in params) {
				if( !first ){
					url = url + "&";
				}
				url = url + key + "=" + escape(params[key]);
				
				first = true;
			}
		}
		azumio.exec(url);
	}
	
	//checkin queue
	function Queue(){
		if(!localStorage["head"] || !localStorage['tail'] ){
			localStorage["head"] = localStorage["tail"] = 0;
		}
		
		this.head = function(){
			return parseInt(localStorage["head"]);
		}
		
		this.tail = function(){
			return parseInt(localStorage["tail"]);
		}
		
		this.push = function(obj){
			var h = this.head();
			localStorage["queue."+h] = JSON.stringify(obj,null," ");
			localStorage["head"] = h+1;
		}
		
		this.peek = function(){
			var t = this.tail();
			var h = this.head();
			if(t>=h)
				return null;
			var cis = localStorage["queue."+t];
			try{
				var ci = JSON.parse(cis);
			}catch(e){
				this.removeTail();
				return this.peek();
			}
			return ci;
		}
		this.removeTail = function(){
			var t = this.tail();
			var h = this.head();
			if(t>=h)
				return false;
			t = t + 1;
			localStorage["tail"] = t;
		}
		
		this.pop = function(){
			var ci = this.peek();
			this.removeTail();
			return ci;
		}
		
		this.all = function(){
			var h = this.head();
			var t = this.tail();
			var q = [];
			while(t<h){
				
					var key = "queue."+(h-1);
					var cis = localStorage.getItem(key);
					
					try{
						var checkin = JSON.parse(cis)
						q.push( checkin );
					}catch(e){}
					
					h = h-1;
				
			}
			return q;
		} 
		return this;
	}
	
	azumio.execQueue = [];
	azumio.execQueue.ready = true;
	azumio.exec = function(url){
		url.processed = false;
		azumio.execQueue.push(url);
		
		if(!azumio.exec.timer){
			azumio.exec.timer = setInterval(azumio.exec.sendNextCommand,10);
		}
	}
	
	azumio.exec.sendNextCommand = function(){
		if(!azumio.execQueue.ready)
			return;
		
		
		
		if(!azumio.gapBridge){
			azumio.gapBridge = document.createElement("iframe");
			azumio.gapBridge.setAttribute("style", "display:none;");
			azumio.gapBridge.setAttribute("height","0px");
			azumio.gapBridge.setAttribute("width","0px");
			azumio.gapBridge.setAttribute("frameborder","0");
			document.documentElement.appendChild(azumio.gapBridge);
	    }
		
		if( azumio.execQueue.length > 0 ){
			url = azumio.execQueue.shift();
			azumio.gapBridge.src = url;
			azumio.execQueue.ready = false;
		}else{
			azumio.execQueue.ready = true;
			clearInterval(azumio.exec.timer);
			delete azumio.exec.timer;
		}
	}
	
	azumio.exec.confirmLastCommand = function(url){
		azumio.execQueue.ready = true;
	}
	
	
	
	azumio.trigger = function(name,payload){
		if( payload ){
			azumio.exec( "azumio:trigger:?name="+name +"&payload="+JSON.stringify(payload));
		}else{
			azumio.exec( "azumio:trigger:?name="+name);
		}
	}
	
	azumio.queue = new Queue();
	
	//browser detection
	azumio.isIPhoneSafari = function(){
		var isSafari = navigator.userAgent.match(/Safari/i) != null;
		var isIPhone =  navigator.userAgent.match(/iPhone/i) != null;
		return isSafari && isIPhone;
	}
	
	azumio.isIPhoneUIWebView = function(){
		var isSafari = navigator.userAgent.match(/Safari/i) != null;
		var isIPhone =  navigator.userAgent.match(/iPhone/i) != null;
		return !isSafari && isIPhone;
	}
	
	azumio.isAndroidWebView = function(){
		return navigator.userAgent.match(/AzumioWebView/i) != null;
	}
	
	if( azumio.isIPhoneUIWebView() ){
		azumio.hasWebViewBoost = true;
	}

})();




//Hash search
var HashSearch = new function () {
       var params;

       this.set = function (key, value) {
          params[key] = value;
          this.push();
       };

       this.get = function (key, value) {
           return params[key];
       };

       this.keyExists = function (key) {
           return params.hasOwnProperty(key);
       };

       this.push= function () {
           var hashBuilder = [], key, value;

           for(key in params) if (params.hasOwnProperty(key)) {
               key = escape(key), value = escape(params[key]); // escape(undefined) == "undefined"
               hashBuilder.push(key + ( (value !== "undefined") ? '=' + value : "" ));
           }

           window.location.hash = hashBuilder.join("&");
       };

       (this.load = function () {
           params = {}
           var hashStr = window.location.hash, hashArray, keyVal
           hashStr = hashStr.substring(1, hashStr.length);
           hashArray = hashStr.split('&');

           for(var i = 0; i < hashArray.length; i++) {
               keyVal = hashArray[i].split('=');
               params[unescape(keyVal[0])] = (typeof keyVal[1] != "undefined") ? unescape(keyVal[1]) : keyVal[1];
           }
       })();
    }



			azumio.version="2011-11-24-04:47";
	
/**
 * 
 */	

(function() {
	if(!window.azumio){
		window.azumio = {};
	}

	if(!window.azumio.utils){
		window.azumio.utils = {};
	}
	var u = window.azumio.utils;

	u.timespanToString = function(t) {
		t = parseFloat(t);
		var now = new Date();
		var span = now.getTime() - t;
		if (span < 1000 * 59) {
			return "" + Math.round(span / 1000) + "s ago";
		}

		if (span < 1000 * 60 * 59) {
			return "" + Math.round(span / (1000 * 60)) + "m ago";
		}

		if (span < 1000 * 60 * 60 * 24) {
			return "" + Math.round(span / (1000 * 60 * 60)) + "h ago";
		}

		if (isNaN(span)) {
			return "";
		}
		// return "" + Math.round(span / (1000 * 60 * 60 * 24)) + "days ago";
		return "" + new Date(t).format("mmmm d, h:MM");
	}
	
	u.confirm = function(text, onyes, onno){
		if( azumio.isIPhoneUIWebView() ){
			u.alert({title:text,cancel:"NO",button1:'YES'},[onno,onyes]);
			
		}else{
			if(confirm(text)){
				if(onyes){
					onyes();
				}
			}else{
				if(onno){
					onno();
				}
			}
		}
	}
	
	u.alert = function(options,callbacks){
		options = options || {};
		url = 'azumio:alert:?title='+escape(options.title);
		
		if(options.message)
			url = url + "&message=" + options.message;
		
		if(options.cancel)
			url = url + "&cancel=" + options.cancel;
		
		if(options.button1)
			url = url + "&button1=" + options.button1;
		
		if(options.button2)
			url = url + "&button2=" + options.button2;
		
		u.alert.callback.forLastCall = callbacks;
		
		azumio.exec(url);
		
	}
	
	u.alert.callback =function(buttonId){
		u.alert.callback.forLastCall[buttonId]();
	}
	
	u.alert.callback.forLastCall=[];
	
	
	u.Queue = function(_name){
		if(!_name)
			_name="default";
		this.name = _name;
		if(!localStorage["queue."+this.name +".head"] || !localStorage["queue."+this.name +".tail"] ){
			localStorage["queue."+this.name +".head"] = localStorage["queue."+this.name +".tail"] = 0;
		}
		
		this.head = function(){
			return parseInt(localStorage["queue."+this.name +".head"]);
		}
		
		this.tail = function(){
			return parseInt(localStorage["queue."+this.name +".tail"]);
		}
		
		this.push = function(obj){
			var h = this.head();
			localStorage["queue."+this.name+"."+h] = JSON.stringify(obj,null," ");
			localStorage["queue."+this.name +".head"] = h+1;
		}
		
		this.peek = function(){
			var t = this.tail();
			var h = this.head();
			if(t>=h)
				return null;
			var cis = localStorage["queue."+this.name+"."+t];
			try{
				var ci = JSON.parse(cis);
			}catch(e){
				this.removeTail();
				return this.peek();
			}
			return ci;
		}
		this.removeTail = function(){
			var t = this.tail();
			var h = this.head();
			if(t>=h)
				return false;
			t = t + 1;
			localStorage["queue."+this.name +".tail"] = t;
		}
		
		this.pop = function(){
			var ci = this.peek();
			this.removeTail();
			return ci;
		}
		
		this.all = function(){
			var h = this.head();
			var t = this.tail();
			var q = [];
			while(t<h){
				var key = "queue."+this.name+"."+(h-1);
				var cis = localStorage.getItem(key);
				var checkin = JSON.parse(cis)
				q.push( checkin );
				h = h-1;
			}
			return q;
		} 
		return this;
	};

})();




/*
 * Date Format 1.2.3
 * (c) 2007-2009 Steven Levithan <stevenlevithan.com>
 * MIT license
 *
 * Includes enhancements by Scott Trenda <scott.trenda.net>
 * and Kris Kowal <cixar.com/~kris.kowal/>
 *
 * Accepts a date, a mask, or a date and a mask.
 * Returns a formatted version of the given date.
 * The date defaults to the current date/time.
 * The mask defaults to dateFormat.masks.default.
 */

var dateFormat = function () {
	var	token = /d{1,4}|m{1,4}|yy(?:yy)?|([HhMsTt])\1?|[LloSZ]|"[^"]*"|'[^']*'/g,
		timezone = /\b(?:[PMCEA][SDP]T|(?:Pacific|Mountain|Central|Eastern|Atlantic) (?:Standard|Daylight|Prevailing) Time|(?:GMT|UTC)(?:[-+]\d{4})?)\b/g,
		timezoneClip = /[^-+\dA-Z]/g,
		pad = function (val, len) {
			val = String(val);
			len = len || 2;
			while (val.length < len) val = "0" + val;
			return val;
		};

	// Regexes and supporting functions are cached through closure
	return function (date, mask, utc) {
		var dF = dateFormat;

		// You can't provide utc if you skip other args (use the "UTC:" mask prefix)
		if (arguments.length == 1 && Object.prototype.toString.call(date) == "[object String]" && !/\d/.test(date)) {
			mask = date;
			date = undefined;
		}

		// Passing date through Date applies Date.parse, if necessary
		date = date ? new Date(date) : new Date;
		if (isNaN(date)) throw SyntaxError("invalid date");

		mask = String(dF.masks[mask] || mask || dF.masks["default"]);

		// Allow setting the utc argument via the mask
		if (mask.slice(0, 4) == "UTC:") {
			mask = mask.slice(4);
			utc = true;
		}

		var	_ = utc ? "getUTC" : "get",
			d = date[_ + "Date"](),
			D = date[_ + "Day"](),
			m = date[_ + "Month"](),
			y = date[_ + "FullYear"](),
			H = date[_ + "Hours"](),
			M = date[_ + "Minutes"](),
			s = date[_ + "Seconds"](),
			L = date[_ + "Milliseconds"](),
			o = utc ? 0 : date.getTimezoneOffset(),
			flags = {
				d:    d,
				dd:   pad(d),
				ddd:  dF.i18n.dayNames[D],
				dddd: dF.i18n.dayNames[D + 7],
				m:    m + 1,
				mm:   pad(m + 1),
				mmm:  dF.i18n.monthNames[m],
				mmmm: dF.i18n.monthNames[m + 12],
				yy:   String(y).slice(2),
				yyyy: y,
				h:    H % 12 || 12,
				hh:   pad(H % 12 || 12),
				H:    H,
				HH:   pad(H),
				M:    M,
				MM:   pad(M),
				s:    s,
				ss:   pad(s),
				l:    pad(L, 3),
				L:    pad(L > 99 ? Math.round(L / 10) : L),
				t:    H < 12 ? "a"  : "p",
				tt:   H < 12 ? "am" : "pm",
				T:    H < 12 ? "A"  : "P",
				TT:   H < 12 ? "AM" : "PM",
				Z:    utc ? "UTC" : (String(date).match(timezone) || [""]).pop().replace(timezoneClip, ""),
				o:    (o > 0 ? "-" : "+") + pad(Math.floor(Math.abs(o) / 60) * 100 + Math.abs(o) % 60, 4),
				S:    ["th", "st", "nd", "rd"][d % 10 > 3 ? 0 : (d % 100 - d % 10 != 10) * d % 10]
			};

		return mask.replace(token, function ($0) {
			return $0 in flags ? flags[$0] : $0.slice(1, $0.length - 1);
		});
	};
}();

// Some common format strings
dateFormat.masks = {
	"default":      "ddd mmm dd yyyy HH:MM:ss",
	shortDate:      "m/d/yy",
	mediumDate:     "mmm d, yyyy",
	longDate:       "mmmm d, yyyy",
	fullDate:       "dddd, mmmm d, yyyy",
	shortTime:      "h:MM TT",
	mediumTime:     "h:MM:ss TT",
	longTime:       "h:MM:ss TT Z",
	isoDate:        "yyyy-mm-dd",
	isoTime:        "HH:MM:ss",
	isoDateTime:    "yyyy-mm-dd'T'HH:MM:ss",
	isoUtcDateTime: "UTC:yyyy-mm-dd'T'HH:MM:ss'Z'"
};

// Internationalization strings
dateFormat.i18n = {
	dayNames: [
		"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat",
		"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"
	],
	monthNames: [
		"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec",
		"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"
	]
};

// For convenience...
Date.prototype.format = function (mask, utc) {
	return dateFormat(this, mask, utc);
};
/*
    http://www.JSON.org/json2.js
    2011-02-23

    Public Domain.

    NO WARRANTY EXPRESSED OR IMPLIED. USE AT YOUR OWN RISK.

    See http://www.JSON.org/js.html


    This code should be minified before deployment.
    See http://javascript.crockford.com/jsmin.html

    USE YOUR OWN COPY. IT IS EXTREMELY UNWISE TO LOAD CODE FROM SERVERS YOU DO
    NOT CONTROL.


    This file creates a global JSON object containing two methods: stringify
    and parse.

        JSON.stringify(value, replacer, space)
            value       any JavaScript value, usually an object or array.

            replacer    an optional parameter that determines how object
                        values are stringified for objects. It can be a
                        function or an array of strings.

            space       an optional parameter that specifies the indentation
                        of nested structures. If it is omitted, the text will
                        be packed without extra whitespace. If it is a number,
                        it will specify the number of spaces to indent at each
                        level. If it is a string (such as '\t' or '&nbsp;'),
                        it contains the characters used to indent at each level.

            This method produces a JSON text from a JavaScript value.

            When an object value is found, if the object contains a toJSON
            method, its toJSON method will be called and the result will be
            stringified. A toJSON method does not serialize: it returns the
            value represented by the name/value pair that should be serialized,
            or undefined if nothing should be serialized. The toJSON method
            will be passed the key associated with the value, and this will be
            bound to the value

            For example, this would serialize Dates as ISO strings.

                Date.prototype.toJSON = function (key) {
                    function f(n) {
                        // Format integers to have at least two digits.
                        return n < 10 ? '0' + n : n;
                    }

                    return this.getUTCFullYear()   + '-' +
                         f(this.getUTCMonth() + 1) + '-' +
                         f(this.getUTCDate())      + 'T' +
                         f(this.getUTCHours())     + ':' +
                         f(this.getUTCMinutes())   + ':' +
                         f(this.getUTCSeconds())   + 'Z';
                };

            You can provide an optional replacer method. It will be passed the
            key and value of each member, with this bound to the containing
            object. The value that is returned from your method will be
            serialized. If your method returns undefined, then the member will
            be excluded from the serialization.

            If the replacer parameter is an array of strings, then it will be
            used to select the members to be serialized. It filters the results
            such that only members with keys listed in the replacer array are
            stringified.

            Values that do not have JSON representations, such as undefined or
            functions, will not be serialized. Such values in objects will be
            dropped; in arrays they will be replaced with null. You can use
            a replacer function to replace those with JSON values.
            JSON.stringify(undefined) returns undefined.

            The optional space parameter produces a stringification of the
            value that is filled with line breaks and indentation to make it
            easier to read.

            If the space parameter is a non-empty string, then that string will
            be used for indentation. If the space parameter is a number, then
            the indentation will be that many spaces.

            Example:

            text = JSON.stringify(['e', {pluribus: 'unum'}]);
            // text is '["e",{"pluribus":"unum"}]'


            text = JSON.stringify(['e', {pluribus: 'unum'}], null, '\t');
            // text is '[\n\t"e",\n\t{\n\t\t"pluribus": "unum"\n\t}\n]'

            text = JSON.stringify([new Date()], function (key, value) {
                return this[key] instanceof Date ?
                    'Date(' + this[key] + ')' : value;
            });
            // text is '["Date(---current time---)"]'


        JSON.parse(text, reviver)
            This method parses a JSON text to produce an object or array.
            It can throw a SyntaxError exception.

            The optional reviver parameter is a function that can filter and
            transform the results. It receives each of the keys and values,
            and its return value is used instead of the original value.
            If it returns what it received, then the structure is not modified.
            If it returns undefined then the member is deleted.

            Example:

            // Parse the text. Values that look like ISO date strings will
            // be converted to Date objects.

            myData = JSON.parse(text, function (key, value) {
                var a;
                if (typeof value === 'string') {
                    a =
/^(\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2}):(\d{2}(?:\.\d*)?)Z$/.exec(value);
                    if (a) {
                        return new Date(Date.UTC(+a[1], +a[2] - 1, +a[3], +a[4],
                            +a[5], +a[6]));
                    }
                }
                return value;
            });

            myData = JSON.parse('["Date(09/09/2001)"]', function (key, value) {
                var d;
                if (typeof value === 'string' &&
                        value.slice(0, 5) === 'Date(' &&
                        value.slice(-1) === ')') {
                    d = new Date(value.slice(5, -1));
                    if (d) {
                        return d;
                    }
                }
                return value;
            });


    This is a reference implementation. You are free to copy, modify, or
    redistribute.
*/

/*jslint evil: true, strict: false, regexp: false */

/*members "", "\b", "\t", "\n", "\f", "\r", "\"", JSON, "\\", apply,
    call, charCodeAt, getUTCDate, getUTCFullYear, getUTCHours,
    getUTCMinutes, getUTCMonth, getUTCSeconds, hasOwnProperty, join,
    lastIndex, length, parse, prototype, push, replace, slice, stringify,
    test, toJSON, toString, valueOf
*/


// Create a JSON object only if one does not already exist. We create the
// methods in a closure to avoid creating global variables.

var JSON;
if (!JSON) {
    JSON = {};
}

(function () {
    "use strict";

    function f(n) {
        // Format integers to have at least two digits.
        return n < 10 ? '0' + n : n;
    }

    if (typeof Date.prototype.toJSON !== 'function') {

        Date.prototype.toJSON = function (key) {

            return isFinite(this.valueOf()) ?
                this.getUTCFullYear()     + '-' +
                f(this.getUTCMonth() + 1) + '-' +
                f(this.getUTCDate())      + 'T' +
                f(this.getUTCHours())     + ':' +
                f(this.getUTCMinutes())   + ':' +
                f(this.getUTCSeconds())   + 'Z' : null;
        };

        String.prototype.toJSON      =
            Number.prototype.toJSON  =
            Boolean.prototype.toJSON = function (key) {
                return this.valueOf();
            };
    }

    var cx = /[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,
        escapable = /[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,
        gap,
        indent,
        meta = {    // table of character substitutions
            '\b': '\\b',
            '\t': '\\t',
            '\n': '\\n',
            '\f': '\\f',
            '\r': '\\r',
            '"' : '\\"',
            '\\': '\\\\'
        },
        rep;


    function quote(string) {

// If the string contains no control characters, no quote characters, and no
// backslash characters, then we can safely slap some quotes around it.
// Otherwise we must also replace the offending characters with safe escape
// sequences.

        escapable.lastIndex = 0;
        return escapable.test(string) ? '"' + string.replace(escapable, function (a) {
            var c = meta[a];
            return typeof c === 'string' ? c :
                '\\u' + ('0000' + a.charCodeAt(0).toString(16)).slice(-4);
        }) + '"' : '"' + string + '"';
    }


    function str(key, holder) {

// Produce a string from holder[key].

        var i,          // The loop counter.
            k,          // The member key.
            v,          // The member value.
            length,
            mind = gap,
            partial,
            value = holder[key];

// If the value has a toJSON method, call it to obtain a replacement value.

        if (value && typeof value === 'object' &&
                typeof value.toJSON === 'function') {
            value = value.toJSON(key);
        }

// If we were called with a replacer function, then call the replacer to
// obtain a replacement value.

        if (typeof rep === 'function') {
            value = rep.call(holder, key, value);
        }

// What happens next depends on the value's type.

        switch (typeof value) {
        case 'string':
            return quote(value);

        case 'number':

// JSON numbers must be finite. Encode non-finite numbers as null.

            return isFinite(value) ? String(value) : 'null';

        case 'boolean':
        case 'null':

// If the value is a boolean or null, convert it to a string. Note:
// typeof null does not produce 'null'. The case is included here in
// the remote chance that this gets fixed someday.

            return String(value);

// If the type is 'object', we might be dealing with an object or an array or
// null.

        case 'object':

// Due to a specification blunder in ECMAScript, typeof null is 'object',
// so watch out for that case.

            if (!value) {
                return 'null';
            }

// Make an array to hold the partial results of stringifying this object value.

            gap += indent;
            partial = [];

// Is the value an array?

            if (Object.prototype.toString.apply(value) === '[object Array]') {

// The value is an array. Stringify every element. Use null as a placeholder
// for non-JSON values.

                length = value.length;
                for (i = 0; i < length; i += 1) {
                    partial[i] = str(i, value) || 'null';
                }

// Join all of the elements together, separated with commas, and wrap them in
// brackets.

                v = partial.length === 0 ? '[]' : gap ?
                    '[\n' + gap + partial.join(',\n' + gap) + '\n' + mind + ']' :
                    '[' + partial.join(',') + ']';
                gap = mind;
                return v;
            }

// If the replacer is an array, use it to select the members to be stringified.

            if (rep && typeof rep === 'object') {
                length = rep.length;
                for (i = 0; i < length; i += 1) {
                    if (typeof rep[i] === 'string') {
                        k = rep[i];
                        v = str(k, value);
                        if (v) {
                            partial.push(quote(k) + (gap ? ': ' : ':') + v);
                        }
                    }
                }
            } else {

// Otherwise, iterate through all of the keys in the object.

                for (k in value) {
                    if (Object.prototype.hasOwnProperty.call(value, k)) {
                        v = str(k, value);
                        if (v) {
                            partial.push(quote(k) + (gap ? ': ' : ':') + v);
                        }
                    }
                }
            }

// Join all of the member texts together, separated with commas,
// and wrap them in braces.

            v = partial.length === 0 ? '{}' : gap ?
                '{\n' + gap + partial.join(',\n' + gap) + '\n' + mind + '}' :
                '{' + partial.join(',') + '}';
            gap = mind;
            return v;
        }
    }

// If the JSON object does not yet have a stringify method, give it one.

    if (typeof JSON.stringify !== 'function') {
        JSON.stringify = function (value, replacer, space) {

// The stringify method takes a value and an optional replacer, and an optional
// space parameter, and returns a JSON text. The replacer can be a function
// that can replace values, or an array of strings that will select the keys.
// A default replacer method can be provided. Use of the space parameter can
// produce text that is more easily readable.

            var i;
            gap = '';
            indent = '';

// If the space parameter is a number, make an indent string containing that
// many spaces.

            if (typeof space === 'number') {
                for (i = 0; i < space; i += 1) {
                    indent += ' ';
                }

// If the space parameter is a string, it will be used as the indent string.

            } else if (typeof space === 'string') {
                indent = space;
            }

// If there is a replacer, it must be a function or an array.
// Otherwise, throw an error.

            rep = replacer;
            if (replacer && typeof replacer !== 'function' &&
                    (typeof replacer !== 'object' ||
                    typeof replacer.length !== 'number')) {
                throw new Error('JSON.stringify');
            }

// Make a fake root object containing our value under the key of ''.
// Return the result of stringifying the value.

            return str('', {'': value});
        };
    }


// If the JSON object does not yet have a parse method, give it one.

    if (typeof JSON.parse !== 'function') {
        JSON.parse = function (text, reviver) {

// The parse method takes a text and an optional reviver function, and returns
// a JavaScript value if the text is a valid JSON text.

            var j;

            function walk(holder, key) {

// The walk method is used to recursively walk the resulting structure so
// that modifications can be made.

                var k, v, value = holder[key];
                if (value && typeof value === 'object') {
                    for (k in value) {
                        if (Object.prototype.hasOwnProperty.call(value, k)) {
                            v = walk(value, k);
                            if (v !== undefined) {
                                value[k] = v;
                            } else {
                                delete value[k];
                            }
                        }
                    }
                }
                return reviver.call(holder, key, value);
            }


// Parsing happens in four stages. In the first stage, we replace certain
// Unicode characters with escape sequences. JavaScript handles many characters
// incorrectly, either silently deleting them, or treating them as line endings.

            text = String(text);
            cx.lastIndex = 0;
            if (cx.test(text)) {
                text = text.replace(cx, function (a) {
                    return '\\u' +
                        ('0000' + a.charCodeAt(0).toString(16)).slice(-4);
                });
            }

// In the second stage, we run the text against regular expressions that look
// for non-JSON patterns. We are especially concerned with '()' and 'new'
// because they can cause invocation, and '=' because it can cause mutation.
// But just to be safe, we want to reject all unexpected forms.

// We split the second stage into 4 regexp operations in order to work around
// crippling inefficiencies in IE's and Safari's regexp engines. First we
// replace the JSON backslash pairs with '@' (a non-JSON character). Second, we
// replace all simple value tokens with ']' characters. Third, we delete all
// open brackets that follow a colon or comma or that begin the text. Finally,
// we look to see that the remaining characters are only whitespace or ']' or
// ',' or ':' or '{' or '}'. If that is so, then the text is safe for eval.

            if (/^[\],:{}\s]*$/
                    .test(text.replace(/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g, '@')
                        .replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g, ']')
                        .replace(/(?:^|:|,)(?:\s*\[)+/g, ''))) {

// In the third stage we use the eval function to compile the text into a
// JavaScript structure. The '{' operator is subject to a syntactic ambiguity
// in JavaScript: it can begin a block or an object literal. We wrap the text
// in parens to eliminate the ambiguity.

                j = eval('(' + text + ')');

// In the optional fourth stage, we recursively walk the new structure, passing
// each name/value pair to a reviver function for possible transformation.

                return typeof reviver === 'function' ?
                    walk({'': j}, '') : j;
            }

// If the text is not JSON parseable, then a SyntaxError is thrown.

            throw new SyntaxError('JSON.parse');
        };
    }
}());
var types={
	"heartrate":{
		"title":"Heart Rate",
		"values":{
			"value1":{
				"unit":"bpm",
				"min":30,
				"max":220,
				"step":1,
				"type":"number"
			}
		},
		"desc":"Measure heart rate in the morning before waking up to track changes"
	},
	"heartraterecovery":{
		"title":"Heart Rate Recovery",
		"values":{
			"value1":{
				"unit":"bpm",
				"min":30,
				"max":220,
				"step":1,
				"type":"number"
			}
		}
	},
	
	"weight":{
		"title":"Weight",
		"values":{
			"value1":{
				"unit":"kg",
				"min":3,
				"max":200,
				"step":0.1,
				"type":"number"
			}
		},
		"desc":"Measure your weight every day at the same time"
	},
	
	"bloodpressure":{
		"title":"Blood pressure",
		"values":{
			"value1":{
				"title":"Systolic(Higher)",
				"unit":"mmHg",
				"min":30,
				"max":220,
				"step":1,
				"type":"number"
			},
			"value2":{
				"title":"Diastolic(Lower)",
				"unit":"mmHg",
				"min":30,
				"max":220,
				"step":1,
				"type":"number"
			}
		},
		valueFormatFunction:function(value1,value2){
			return value1+"/"+value2;
		},
		"desc":"Hypertension tracking"
	},
	
	"sleep":{
		"title":"Sleep",
		"desc":"Check-in when you go to sleep"
	},
	
	"stresslevel":{
		"title":"Stress Level",
		"desc":"Stress Level",
		"unit":"%"
	},
	
	"azumio_comment":{
		"unit":""
	},
	
	"azumio":{
		"unit":"",
		"title":"Message from Azumio"
	},
	
	"stressdoctor":{
		"title":"Balance points",
		"desc":"Balance points",
		"unit":""
	},
	
	"wakeup":{
		"title":"Wakeup",
		"values":{
			"value1":{
				"title":"Sleep time",
				"min":0,
				"max":24,
				"step":1/60,
				"type":"number",
				"unit":"hour"
			}
		},
		"desc":"Check-out of sleep. Record your sleep time"
	}
};
