

(function(){
	if(!window.azumio){
		window.azumio =  {};
	}
	var azumio = window.azumio;
	
	azumio.version = 11;
	azumio.hasWebViewBoost = false;
	
	azumio.defaultSettings = {
			apidomain: 'https://azumio-com.azumio.com',
			client_id: 'com.azumio.unknown'
	};
	
	var _storedSettingsKey = 'azumio.settings';
	if(!azumio.settings){
		azumio.settings = azumio.defaultSettings;
		if( localStorage[_storedSettingsKey] ){
			try{
				azumio.settings = JSON.parse(localStorage[_storedSettingsKey]);
			}catch(e){}
		}
	}else{
		localStorage[_storedSettingsKey] = JSON.stringify(azumio.settings);
	}
	

	//do the check
	try{
		if(azumio.isIPhoneUIWebView()){
			azumio.exec("azumio:ping:....");
		}
	}catch(e){}
	
	azumio.onPong = function(version){
		azumio.hasWebViewBoost = true;
	}
	
	//attach to checkin button
	$("a.checkin").click(
		function(){		
			try{
				//azumio.showProgressOverlay(true);//FIXME:
				
				var checkin = azumio.createCheckinFromForm();
				
				//stop location tracking
				azumio.locationServicesOff();
				
				
				azumio.addCheckin(checkin);
				azumio.sync();//sync stale checkins
				
				$("div.checkinForm").hide(200);
				$("div.overlay").remove();
			}catch(e){
				azumio.logError("Error generating checkin " + e);
			}
			//check if there is a token and if user profile is loaded.
		}
	);
	
	azumio.lastId = 0;
	
	azumio.newId = function(seed){
		if(!seed)
			seed = new Date().getTime();
		azumio.lastId = azumio.lastId+1;
		return azumio.lastId+"#"+seed;
	}
	
	azumio.createCheckinFromForm = function(form,checkin){
		if(!form)
			form = $(document);
		
		try{
			//azumio.showProgressOverlay(true);//FIXME:
			
			if( !checkin )
				checkin = {};
			
			if(!checkin.timestamp)
				checkin.timestamp = new Date().getTime();
			
			checkin.type = form.find("input[name='type']").val();
			checkin.note = form.find("input[name='note']").val();
			checkin.value = form.find("input[name='value']").val();
			
			
			var facebook = false;
			var twitter = false;
			
			var broadcast = [];
			
			if( form.find("input[name='facebook']").is(':checked') ){
				broadcast.push("facebook");
			}
			
			if( form.find("input[name='twitter']").is(':checked') ){
				broadcast.push("twitter");
			}
			
			
			if( form.find(".share-buttons button.twitter").hasClass("checked") ){
				broadcast.push("twitter");
			}
			
			if( form.find(".share-buttons button.facebook").hasClass("checked") ){
				broadcast.push("facebook");
			}
			
			
			if( broadcast.length > 0 ){
				checkin.broadcast= broadcast.join(",");
			}else{
				delete checkin.broadcast;
			}
			
				
			if(azumio.geoloc){
				checkin.location = azumio.geoloc;
			}
			
			if( azumio.settings.clientid ){
				checkin.client_id = azumio.settings.clientid;
			}

			return checkin;
		}catch(e){
			azumio.logError("Error generating checkin " + e);
		}
		
	}
	
	azumio.attachFilesToCheckin = function(checkin){
		if( azumio.tempFile != null  ){
			checkin.attachments = [];
			checkin.attachments.push(azumio.tempFile);
			azumio.tempFile = null;
		}
	}
	
	azumio.getUserProfile = function(requestFromOnlineIfNeedded){
		var u = localStorage["/api/users/self"];
		if(u){
			return JSON.parse(u)
		}else{
			if(requestFromOnlineIfNeedded){
				azumio.jsonCall("/api/users/self",{success:function(data){
					localStorage["/api/users/self"] = JSON.stringify(data);
				}});
			}
			return {};
		}
	}
	
	azumio.updateUserProfile = function(profile){
		var u = localStorage["/api/users/self"];
		if(u){
			u = JSON.parse(u);
		}else{
			u = {};
		}
		
		u = profile;
		localStorage["/api/users/self"] = JSON.stringify(u);
	}
	
	azumio.jsonDelete = function(endpoint,obj)
	{
		if(!obj){
			obj = {};
		}
		obj.method = "DELETE";
		azumio.jsonCall(endpoint, obj)
	}
	
	azumio.jsonPost = function(endpoint,obj)
	{
		if(!obj){
			obj = {};
		}
		obj.method = "POST";
		azumio.jsonCall(endpoint, obj)
	}
	
	azumio.jsonGet = function(endpoint,obj)
	{
		if(!obj){
			obj = {};
		}
		obj.method = "GET";
		azumio.jsonCall(endpoint, obj)
	}
	
	//do a json call to azumio portal
	azumio.jsonCall = function(endpoint,obj){
		var h={};
		if(azumio.auth.isAuthenticated()){
			h["Authentication"] = "OAuth " + azumio.auth.getOAuthToken();
		}
		h["X-Client-ID"] = azumio.settings.client_id;
		h["X-Client-UUID"] = azumio.settings.device_uuid;
		h["X-Client-Version"] = azumio.settings.client_version;
		
		endpoint = (azumio.settings.apidomain+endpoint);
		
		azumio.logDebug(endpoint);
		
		$.ajax({
			timeout:30000,//TODO: check correct time
			url:endpoint,
			type:obj.method ? obj.method:"GET",
			success:function(data){
				if( typeof data.meta == 'undefined' || typeof data.meta.code == 'undefined' ){
					data = {meta:{code:500,errorDetail:'Unrecognized response from server!'}};
				}
		
				if(data.meta.code == 200 ){
					if(obj.success){
						obj.success(data); 
					}
				}else if(data.meta.code == 401){
					azumio.logDebug("Not authorized"); 
					azumio.auth.logout();
					//if(azumio.auth.isAuthenticated()){
					//	azumio.showLogin(obj.unauthorized);
					//}
					
					if(obj.error){
						obj.error(data);
					}
				}else{
					azumio.logDebug("Error durring API call " + data.meta.code + " " + data.meta.errorDetail);
					if(obj.error){
						obj.error(data);
					}
				}
			},
			headers:h,
			data:obj.data,
			error:function(jqXHR, textStatus, errorThrown){
				azumio.logError(textStatus + " " + errorThrown );
				if(obj.error){
					obj.error({meta:{code:0,errorDetail: textStatus + " Check your internet connection!"}});
					azumio.logDebug("fail")
				}
			},
			complete:function(a,status){
				if( obj.complete ){
					obj.complete(status);
				}
			}
		});
	}
	
	
	azumio.showLogin = function(){

		azumio.logDebug("Need to show login");
	
	
		azumio.auth.showLogin();
		
		//window.open ("/login/mobileui?redirect_uri=/mobileui/closewindow.jsp","mywindow","menubar=0,resizable=1,width=350,height=250");
	}
	
	azumio.onLoginWindowClose = function(){

	};
	
	azumio.setOAuthToken = function(token){
		azumio.auth.setOAuthToken(token);
	}
	
	azumio.lastOpenWindowCloseCallback = null;
	azumio.openWindow = function(url,closeCallback){
		
		azumio.lastOpenWindowCloseCallback = closeCallback;
		azumio.logDebug("Open window "+url);

		if( azumio.isIPhoneUIWebView() || azumio.isAndroidWebView()){
			azumio.exec( "window:"+url);
		}else{
			$("body").append("<iframe id='azumioWindow' class='overlay' width='350' height='100%'></iframe>");
			$("#azumioWindow").attr("src",url);
		}
	}
	
	azumio.returnFromWindow = function(obj){
		azumio.logDebug("Return from window "+obj)
		if( azumio.isIPhoneUIWebView() || azumio.isAndroidWebView() ){
			azumio.exec( "return:"+obj );
		}else{
			azumio.logDebug("Closing a window");
			parent.azumio.onReturnFromWindow(obj);
			$('iframe#azumioWindow', window.parent.document).remove();
		}
	}
	
	azumio.onReturnFromWindow = function(obj){
		//("returning from window");
		azumio.logDebug("onReturn from window " + obj);
		eval(obj+";");//FIXME:check for security problems
		
	}
	
	azumio.onChildWindowClose = function(){
		azumio.logDebug("onChildWindowClose");
		if(azumio.lastOpenWindowCloseCallback){
			azumio.lastOpenWindowCloseCallback();
		}
	}

	azumio.showProgressOverlay = function(onOff){
		if(onOff && !document.getElementById("progressOverlay")){
			$("body").append("<div id='progressOverlay'></div>");
		}
		
		if(onOff){
			$("#progressOverlay").show(500);
		}else{
			$("#progressOverlay").hide(500);
		}
	}
	
	azumio.cachedCheckins = [];
	azumio.getCheckins = function(callback,filters,onError){
		azumio.jsonGet("/v1/checkins",{
			success:function(data){
				var ci = data.checkins;
				callback(ci,data.hasMore);
			},
			error:function(e){
				//return cached + localqueue
				azumio.logError("Loading failed " + JSON.stringify(e));
				if(onError){
					onError(e);
				}
			},
			data:filters
		});
	}
	
	azumio.getUncommitedCheckins = function(){
		var list = azumio.queue.all();
		
		var filteredList = [];
		var cnt = list.length;
		var element;
		var i;
		var remoteids = {};
		var ids = {};
		while( element = list.shift()){
			if( typeof element.confirmed  != 'undefined' && element.confirmed == false)
				continue;
			
			if( typeof element.deleted  != 'undefined' && element.deleted == true ){
				if( element.remoteid )
					remoteids[element.remoteid] = true;
				if( element.id )
					ids[element.id] = true;
				continue;
			}
			//check if duplicate
			if( element.remoteid && remoteids[element.remoteid] )
				continue;
			
			if(  element.id && ids[element.is] )
				continue;
			
			if( element.remoteid )
				remoteids[element.remoteid] = true;
			if( element.id )
				ids[element.id] = true;
			
			filteredList.push(element);
			
		}
		//merge updates
		
		return filteredList;
	}
	
	azumio.addCheckin = function(checkin){
		//alert( JSON.stringify(checkin) );
		
		//add checkin to queue and later sync it in bg
		azumio.queue.push(checkin);
	}
	
	azumio.deleteCheckin = function(id,obj){
		azumio.jsonDelete("/v1/checkins/"+id, obj );
	}
	
	
	//geoloc
	azumio.loginHandlers = [];
	azumio.loggendIn = false;
	azumio.onLogin = function(handler){
		azumio.logInfo("onLogin");
		if(handler){
			azumio.loginHandlers.push(handler);
		}else{
			azumio.logDebug("Logged in");
			for(var i=0;i < azumio.loginHandlers.length;i++){
				azumio.loginHandlers[i]();
			}
		}
		azumio.sync();
	}
	
	azumio.getLocation = function(){
		if(azumio.hasWebViewBoost){
			setTimeout(function(){
				azumio.locationServicesOff();
			},20000);
			
			setTimeout(function(){
			 azumio.exec( "azumio:locationServicesOn:" );
			},1);
			
		}else if (navigator.geolocation) {
			  var error = function(e){};
			  navigator.geolocation.getCurrentPosition(onLocationChangeHtml5, error);
		} else {
			azumio.logInfo('Location services not supported');
		}
	}
	
	azumio.locationServicesOff = function(){
		if(azumio.hasWebViewBoost){
			azumio.exec( "azumio:locationServicesOff:" );
		}
	}
	
	azumio.onLocationChange = function(lat,long,accur){
		azumio.geoloc = "geo:"+lat+","+long+";u="+accur;
		azumio.logInfo("location " + azumio.geoloc);
		$(window).trigger("azumio.locationChange", azumio.geoloc);
	}

	azumio.geoloc = false;
	function onLocationChangeHtml5(pos) {
		azumio.geoloc = "geo:"+pos.coords.latitude+","+pos.coords.longitude+";u="+pos.coords.accuracy;
		$(window).trigger("azumio.locationChange", azumio.geoloc);
	}
	
	azumio.tempFile = null;
	
	azumio.setTempFile = function(name,file){

		if(file.substring(0,3)=="AAA" && file.substring(3,6)=="AAA"){
			try{
				var raw = atob(file);
				raw = raw.substring(100000);
				file = btoa(raw);
			}catch(e){

			}
		}else{
			
		}
		azumio.tempFile = {};
		azumio.tempFile.name = name;
		azumio.tempFile.file = file;
	}
	
	azumio.addAttachment = function(name,file){
		azumio.tempFile = {};
		azumio.tempFile.name = name;
		azumio.tempFile.file = file;
	}

	azumio.OFF = 0;
	azumio.ERROR = 1;
	azumio.INFO = 2;
	azumio.DEBUG = 3;
	
	azumio.logLevel = azumio.OFF;
	
	azumio.logError = function(a){
		if( azumio.logLevel >= azumio.ERROR ){
			console.log("ERROR: " + a);
		}
		try{
			
			//window.location="log:Error:"+encodeURI(a);
			
		}catch(e){};
	}
	
	azumio.logInfo = function(a){
		if( azumio.logLevel >= azumio.INFO ){
			console.log("INFO: " + a);
		}
		try{
			//window.location="log:Info:"+encodeURI(a);
		}catch(e){};
	}
	
	azumio.logDebug = function(a){
		if( azumio.logLevel >= azumio.DEBUG ){
			console.log("DEBUG: " + a);
		}
		try{
			//window.location="log:Debug:"+encodeURI(a);
		}catch(e){};
	}
	
	//checkin sync
	//sync checkins in queue
	azumio.sync = function(){
		if(!azumio.auth.isAuthenticated()){
			return;
		}
		azumio.logInfo('azumio.sync()');
		azumio.onSyncStart();
		azumio.syncWorker();
	}
	
	azumio.syncWorker = function(){
		azumio.logDebug("syncWorker()");
		var checkin = azumio.queue.peek();
		if(!checkin){
			azumio.onSyncComplete();
			return;
		}
		
		azumio.logDebug("syncWorker() jsonCall");
		
		azumio.jsonPost("/v1/checkins", {
			success:function(data){
				
				var checkin = azumio.queue.peek();
				azumio.queue.removeTail();
				$(window).trigger("azumio.timeline.update",data.checkin);
				
				azumio.syncWorker();
			},
			error:function(obj){
				if( obj.meta.code == 409 || obj.meta.code == 400){
					azumio.queue.removeTail();
					azumio.syncWorker();
				}else{
					//alert(obj.meta.code);
					azumio.logDebug(obj.meta.code + " " + obj.meta.msg);
				}
			},
			data:{
				"json":JSON.stringify(checkin,null," ")
			}
		});
	}
	
	azumio.onSyncStart = function(){
		$(window).trigger("azumio.sync.start");
	}
	
	azumio.onSyncComplete = function(){
		$(window).trigger("azumio.sync.complete");
	}
	
	azumio.setCheckinButtonState = function(stateClass){
		$("button.checkinLuncher").removeClass("idle");
		$("button.checkinLuncher").removeClass("working");
		$("button.checkinLuncher").removeClass("complete");
		$("button.checkinLuncher").addClass(stateClass);
	}
	
	azumio.trackEvent = function(name,params){
		var url = "azumio:trackEvent:"+name;
		if( params ){
			url = url +"?";
			var first = false;
			for ( var key in params) {
				if( !first ){
					url = url + "&";
				}
				url = url + key + "=" + escape(params[key]);
				
				first = true;
			}
		}
		azumio.exec(url);
	}
	
	//checkin queue
	function Queue(){
		if(!localStorage["head"] || !localStorage['tail'] ){
			localStorage["head"] = localStorage["tail"] = 0;
		}
		
		this.head = function(){
			return parseInt(localStorage["head"]);
		}
		
		this.tail = function(){
			return parseInt(localStorage["tail"]);
		}
		
		this.push = function(obj){
			var h = this.head();
			localStorage["queue."+h] = JSON.stringify(obj,null," ");
			localStorage["head"] = h+1;
		}
		
		this.peek = function(){
			var t = this.tail();
			var h = this.head();
			if(t>=h)
				return null;
			var cis = localStorage["queue."+t];
			try{
				var ci = JSON.parse(cis);
			}catch(e){
				this.removeTail();
				return this.peek();
			}
			return ci;
		}
		this.removeTail = function(){
			var t = this.tail();
			var h = this.head();
			if(t>=h)
				return false;
			t = t + 1;
			localStorage["tail"] = t;
		}
		
		this.pop = function(){
			var ci = this.peek();
			this.removeTail();
			return ci;
		}
		
		this.all = function(){
			var h = this.head();
			var t = this.tail();
			var q = [];
			while(t<h){
				
					var key = "queue."+(h-1);
					var cis = localStorage.getItem(key);
					
					try{
						var checkin = JSON.parse(cis)
						q.push( checkin );
					}catch(e){}
					
					h = h-1;
				
			}
			return q;
		} 
		return this;
	}
	
	azumio.execQueue = [];
	azumio.execQueue.ready = true;
	azumio.exec = function(url){
		url.processed = false;
		azumio.execQueue.push(url);
		
		if(!azumio.exec.timer){
			azumio.exec.timer = setInterval(azumio.exec.sendNextCommand,10);
		}
	}
	
	azumio.exec.sendNextCommand = function(){
		if(!azumio.execQueue.ready)
			return;
		
		
		
		if(!azumio.gapBridge){
			azumio.gapBridge = document.createElement("iframe");
			azumio.gapBridge.setAttribute("style", "display:none;");
			azumio.gapBridge.setAttribute("height","0px");
			azumio.gapBridge.setAttribute("width","0px");
			azumio.gapBridge.setAttribute("frameborder","0");
			document.documentElement.appendChild(azumio.gapBridge);
	    }
		
		if( azumio.execQueue.length > 0 ){
			url = azumio.execQueue.shift();
			azumio.gapBridge.src = url;
			azumio.execQueue.ready = false;
		}else{
			azumio.execQueue.ready = true;
			clearInterval(azumio.exec.timer);
			delete azumio.exec.timer;
		}
	}
	
	azumio.exec.confirmLastCommand = function(url){
		azumio.execQueue.ready = true;
	}
	
	
	
	azumio.trigger = function(name,payload){
		if( payload ){
			azumio.exec( "azumio:trigger:?name="+name +"&payload="+JSON.stringify(payload));
		}else{
			azumio.exec( "azumio:trigger:?name="+name);
		}
	}
	
	azumio.queue = new Queue();
	
	//browser detection
	azumio.isIPhoneSafari = function(){
		var isSafari = navigator.userAgent.match(/Safari/i) != null;
		var isIPhone =  navigator.userAgent.match(/iPhone/i) != null;
		return isSafari && isIPhone;
	}
	
	azumio.isIPhoneUIWebView = function(){
		var isSafari = navigator.userAgent.match(/Safari/i) != null;
		var isIPhone =  navigator.userAgent.match(/iPhone/i) != null;
		return !isSafari && isIPhone;
	}
	
	azumio.isAndroidWebView = function(){
		return navigator.userAgent.match(/AzumioWebView/i) != null;
	}
	
	if( azumio.isIPhoneUIWebView() ){
		azumio.hasWebViewBoost = true;
	}

})();




//Hash search
var HashSearch = new function () {
       var params;

       this.set = function (key, value) {
          params[key] = value;
          this.push();
       };

       this.get = function (key, value) {
           return params[key];
       };

       this.keyExists = function (key) {
           return params.hasOwnProperty(key);
       };

       this.push= function () {
           var hashBuilder = [], key, value;

           for(key in params) if (params.hasOwnProperty(key)) {
               key = escape(key), value = escape(params[key]); // escape(undefined) == "undefined"
               hashBuilder.push(key + ( (value !== "undefined") ? '=' + value : "" ));
           }

           window.location.hash = hashBuilder.join("&");
       };

       (this.load = function () {
           params = {}
           var hashStr = window.location.hash, hashArray, keyVal
           hashStr = hashStr.substring(1, hashStr.length);
           hashArray = hashStr.split('&');

           for(var i = 0; i < hashArray.length; i++) {
               keyVal = hashArray[i].split('=');
               params[unescape(keyVal[0])] = (typeof keyVal[1] != "undefined") ? unescape(keyVal[1]) : keyVal[1];
           }
       })();
    }



			azumio.version="2011-11-24-04:47";
	