/**
 * 
 */	

(function() {
	if(!window.azumio){
		window.azumio = {};
	}

	if(!window.azumio.utils){
		window.azumio.utils = {};
	}
	var u = window.azumio.utils;

	u.timespanToString = function(t) {
		t = parseFloat(t);
		var now = new Date();
		var span = now.getTime() - t;
		if (span < 1000 * 59) {
			return "" + Math.round(span / 1000) + "s ago";
		}

		if (span < 1000 * 60 * 59) {
			return "" + Math.round(span / (1000 * 60)) + "m ago";
		}

		if (span < 1000 * 60 * 60 * 24) {
			return "" + Math.round(span / (1000 * 60 * 60)) + "h ago";
		}

		if (isNaN(span)) {
			return "";
		}
		// return "" + Math.round(span / (1000 * 60 * 60 * 24)) + "days ago";
		return "" + new Date(t).format("mmmm d, h:MM");
	}
	
	u.confirm = function(text, onyes, onno){
		if( azumio.isIPhoneUIWebView() ){
			u.alert({title:text,cancel:"NO",button1:'YES'},[onno,onyes]);
			
		}else{
			if(confirm(text)){
				if(onyes){
					onyes();
				}
			}else{
				if(onno){
					onno();
				}
			}
		}
	}
	
	u.alert = function(options,callbacks){
		options = options || {};
		url = 'azumio:alert:?title='+escape(options.title);
		
		if(options.message)
			url = url + "&message=" + options.message;
		
		if(options.cancel)
			url = url + "&cancel=" + options.cancel;
		
		if(options.button1)
			url = url + "&button1=" + options.button1;
		
		if(options.button2)
			url = url + "&button2=" + options.button2;
		
		u.alert.callback.forLastCall = callbacks;
		
		azumio.exec(url);
		
	}
	
	u.alert.callback =function(buttonId){
		u.alert.callback.forLastCall[buttonId]();
	}
	
	u.alert.callback.forLastCall=[];
	
	
	u.Queue = function(_name){
		if(!_name)
			_name="default";
		this.name = _name;
		if(!localStorage["queue."+this.name +".head"] || !localStorage["queue."+this.name +".tail"] ){
			localStorage["queue."+this.name +".head"] = localStorage["queue."+this.name +".tail"] = 0;
		}
		
		this.head = function(){
			return parseInt(localStorage["queue."+this.name +".head"]);
		}
		
		this.tail = function(){
			return parseInt(localStorage["queue."+this.name +".tail"]);
		}
		
		this.push = function(obj){
			var h = this.head();
			localStorage["queue."+this.name+"."+h] = JSON.stringify(obj,null," ");
			localStorage["queue."+this.name +".head"] = h+1;
		}
		
		this.peek = function(){
			var t = this.tail();
			var h = this.head();
			if(t>=h)
				return null;
			var cis = localStorage["queue."+this.name+"."+t];
			try{
				var ci = JSON.parse(cis);
			}catch(e){
				this.removeTail();
				return this.peek();
			}
			return ci;
		}
		this.removeTail = function(){
			var t = this.tail();
			var h = this.head();
			if(t>=h)
				return false;
			t = t + 1;
			localStorage["queue."+this.name +".tail"] = t;
		}
		
		this.pop = function(){
			var ci = this.peek();
			this.removeTail();
			return ci;
		}
		
		this.all = function(){
			var h = this.head();
			var t = this.tail();
			var q = [];
			while(t<h){
				var key = "queue."+this.name+"."+(h-1);
				var cis = localStorage.getItem(key);
				var checkin = JSON.parse(cis)
				q.push( checkin );
				h = h-1;
			}
			return q;
		} 
		return this;
	};

})();




/*
 * Date Format 1.2.3
 * (c) 2007-2009 Steven Levithan <stevenlevithan.com>
 * MIT license
 *
 * Includes enhancements by Scott Trenda <scott.trenda.net>
 * and Kris Kowal <cixar.com/~kris.kowal/>
 *
 * Accepts a date, a mask, or a date and a mask.
 * Returns a formatted version of the given date.
 * The date defaults to the current date/time.
 * The mask defaults to dateFormat.masks.default.
 */

var dateFormat = function () {
	var	token = /d{1,4}|m{1,4}|yy(?:yy)?|([HhMsTt])\1?|[LloSZ]|"[^"]*"|'[^']*'/g,
		timezone = /\b(?:[PMCEA][SDP]T|(?:Pacific|Mountain|Central|Eastern|Atlantic) (?:Standard|Daylight|Prevailing) Time|(?:GMT|UTC)(?:[-+]\d{4})?)\b/g,
		timezoneClip = /[^-+\dA-Z]/g,
		pad = function (val, len) {
			val = String(val);
			len = len || 2;
			while (val.length < len) val = "0" + val;
			return val;
		};

	// Regexes and supporting functions are cached through closure
	return function (date, mask, utc) {
		var dF = dateFormat;

		// You can't provide utc if you skip other args (use the "UTC:" mask prefix)
		if (arguments.length == 1 && Object.prototype.toString.call(date) == "[object String]" && !/\d/.test(date)) {
			mask = date;
			date = undefined;
		}

		// Passing date through Date applies Date.parse, if necessary
		date = date ? new Date(date) : new Date;
		if (isNaN(date)) throw SyntaxError("invalid date");

		mask = String(dF.masks[mask] || mask || dF.masks["default"]);

		// Allow setting the utc argument via the mask
		if (mask.slice(0, 4) == "UTC:") {
			mask = mask.slice(4);
			utc = true;
		}

		var	_ = utc ? "getUTC" : "get",
			d = date[_ + "Date"](),
			D = date[_ + "Day"](),
			m = date[_ + "Month"](),
			y = date[_ + "FullYear"](),
			H = date[_ + "Hours"](),
			M = date[_ + "Minutes"](),
			s = date[_ + "Seconds"](),
			L = date[_ + "Milliseconds"](),
			o = utc ? 0 : date.getTimezoneOffset(),
			flags = {
				d:    d,
				dd:   pad(d),
				ddd:  dF.i18n.dayNames[D],
				dddd: dF.i18n.dayNames[D + 7],
				m:    m + 1,
				mm:   pad(m + 1),
				mmm:  dF.i18n.monthNames[m],
				mmmm: dF.i18n.monthNames[m + 12],
				yy:   String(y).slice(2),
				yyyy: y,
				h:    H % 12 || 12,
				hh:   pad(H % 12 || 12),
				H:    H,
				HH:   pad(H),
				M:    M,
				MM:   pad(M),
				s:    s,
				ss:   pad(s),
				l:    pad(L, 3),
				L:    pad(L > 99 ? Math.round(L / 10) : L),
				t:    H < 12 ? "a"  : "p",
				tt:   H < 12 ? "am" : "pm",
				T:    H < 12 ? "A"  : "P",
				TT:   H < 12 ? "AM" : "PM",
				Z:    utc ? "UTC" : (String(date).match(timezone) || [""]).pop().replace(timezoneClip, ""),
				o:    (o > 0 ? "-" : "+") + pad(Math.floor(Math.abs(o) / 60) * 100 + Math.abs(o) % 60, 4),
				S:    ["th", "st", "nd", "rd"][d % 10 > 3 ? 0 : (d % 100 - d % 10 != 10) * d % 10]
			};

		return mask.replace(token, function ($0) {
			return $0 in flags ? flags[$0] : $0.slice(1, $0.length - 1);
		});
	};
}();

// Some common format strings
dateFormat.masks = {
	"default":      "ddd mmm dd yyyy HH:MM:ss",
	shortDate:      "m/d/yy",
	mediumDate:     "mmm d, yyyy",
	longDate:       "mmmm d, yyyy",
	fullDate:       "dddd, mmmm d, yyyy",
	shortTime:      "h:MM TT",
	mediumTime:     "h:MM:ss TT",
	longTime:       "h:MM:ss TT Z",
	isoDate:        "yyyy-mm-dd",
	isoTime:        "HH:MM:ss",
	isoDateTime:    "yyyy-mm-dd'T'HH:MM:ss",
	isoUtcDateTime: "UTC:yyyy-mm-dd'T'HH:MM:ss'Z'"
};

// Internationalization strings
dateFormat.i18n = {
	dayNames: [
		"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat",
		"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"
	],
	monthNames: [
		"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec",
		"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"
	]
};

// For convenience...
Date.prototype.format = function (mask, utc) {
	return dateFormat(this, mask, utc);
};
