Azumio = function(){
	this.version = 10;

	//detect AZWebViewBoost
	this.hasWebViewBoost = false;
	//do the check
	try{
		if(this.isIPhoneUIWebView()){
			window.location="azumio:ping:....";
		}
	}catch(e){}
	
	this.onPong = function(version){
		azumio.hasWebViewBoost = true;
		
	}
	
	//attach to checkin button
	$("a.checkin").click(
		function(){		
			try{
			//azumio.showProgressOverlay(true);//FIXME:
			
			var checkin = {};
			checkin.timestamp = new Date().getTime();
			checkin.type = $("input[name='type']").val();
			checkin.note = $("input[name='note']").val();
			checkin.value = $("input[name='value']").val();
			if( $("input[name='facebook']").is(':checked') ){
				checkin.broadcast="facebook";
			}
			
			if( $("input[name='twitter']").is(':checked') ){
				checkin.broadcast="twitter";
			}
			
			if( $("input[name='facebook']").is(':checked')  && $("input[name='twitter']").is(':checked') ){
				checkin.broadcast="facebook,twitter";
			}
				
			if(geoloc){
				checkin.location = geoloc;
			}
			
			//stop location tracking
			azumio.locationServicesOff();
			
			//azumio.logDebug("Pretemp2 " + azumio.tempFile);
			
			if( azumio.tempFile != null  ){
				checkin.attachments = [];
				checkin.attachments.push(azumio.tempFile);
				//azumio.tempFile = null;
			}
			
			//$("div#console").append("<pre>"+JSON.stringify(checkin,null,' ')+"</pre>");
			//azumio.logDebug(JSON.stringify(checkin));
			
			azumio.addCheckin(checkin);
			azumio.sync();//sync stale checkins
			
			$("div.checkinForm").hide(200);
			$("div.overlay").remove();
			}catch(e){
				azumio.logError("Error generating checkin " + e);
			}
			//check if there is a token and if user profile is loaded.
		}
	);
	
	
	this.getUserProfile = function(requestFromOnlineIfNeedded){
		var u = localStorage["/api/users/self"];
		if(u){
			return JSON.parse(u)
		}else{
			if(requestFromOnlineIfNeedded){
				azumio.jsonCall("/api/users/self",{success:function(data){
					localStorage["/api/users/self"] = JSON.stringify(data);
				}});
			}
			return {};
		}
	}
	
	this.updateUserProfile = function(profile){
		var u = localStorage["/api/users/self"];
		if(u){
			u = JSON.parse(u);
		}else{
			u = {};
		}
		
		u = profile;
		localStorage["/api/users/self"] = JSON.stringify(u);
	}
	
	this.jsonDelete = function(endpoint,obj)
	{
		if(!obj){
			obj = {};
		}
		obj.method = "DELETE";
		azumio.jsonCall(endpoint, obj)
	}
	
	this.jsonPost = function(endpoint,obj)
	{
		if(!obj){
			obj = {};
		}
		obj.method = "POST";
		azumio.jsonCall(endpoint, obj)
	}
	
	this.jsonGet = function(endpoint,obj)
	{
		if(!obj){
			obj = {};
		}
		obj.method = "GET";
		azumio.jsonCall(endpoint, obj)
	}
	
	//do a json call to azumio portal
	this.jsonCall = function(endpoint,obj){
		var h={};
		if(localStorage["oauth_token"]){
			//h["Authentication"] = "OAuth " + localStorage["oauth_token"];
		}
		
		$.ajax({
			url:endpoint,
			type:obj.method ? obj.method:"GET",
			success:function(data){
				if(data.meta.code == 200 ){
					if(obj.success){
						obj.success(data);
					}
				}else if(data.meta.code == 401){
					azumio.logDebug("Not authorized");
					azumio.showLogin(obj.unauthorized);
					if(obj.error){
						obj.error(data);
					}
				}else{
					azumio.logDebug("Error durring json call " + data.meta.code + " " + data.meta.errorDetail);
					obj.error(data);
				}
			},
			headers:h,
			data:obj.data,
			error:function(jqXHR, textStatus, errorThrown){
				if(obj.error){
					obj.error({meta:{code:0,errorDetail:textStatus}});
					azumio.logDebug("fail")
				}
			}
		});
	}
	
	this.showLogin = function(){
		azumio.logDebug("Need to show login");
		//azumio.logDebug("sl3");
		azumio.openWindow("/authorize/mobileui?redirect_uri=/mobileui/closewindow.jsp?javascript=azumio.onLogin()",azumio.onLoginWindowClose);
		//window.open ("/login/mobileui?redirect_uri=/mobileui/closewindow.jsp","mywindow","menubar=0,resizable=1,width=350,height=250");
	}
	
	this.onLoginWindowClose = function(){

	};
	
	this.lastOpenWindowCloseCallback = null;
	this.openWindow = function(url,closeCallback){
		azumio.lastOpenWindowCloseCallback = closeCallback;
		azumio.logDebug("Open window "+url);

		if( azumio.isIPhoneUIWebView() || azumio.isAndroidWebView()){
			window.location = "window:"+url;
		}else{
			$("body").append("<iframe id='azumioWindow' class='overlay' width='350' height='100%'></iframe>");
			$("#azumioWindow").attr("src",url);
		}
	}
	
	this.returnFromWindow = function(obj){
		azumio.logDebug("Return from window "+obj)
		if( azumio.isIPhoneUIWebView() || azumio.isAndroidWebView() ){
			window.location = "return:"+obj;
		}else{
			azumio.logDebug("Closing a window");
			parent.azumio.onReturnFromWindow(obj);
			$('iframe#azumioWindow', window.parent.document).remove();
		}
	}
	
	this.onReturnFromWindow = function(obj){
		//("returning from window");
		azumio.logDebug("onReturn from window " + obj);
		eval(obj+";");//FIXME:check for security problems
		
	}
	
	this.onChildWindowClose = function(){
		azumio.logDebug("onChildWindowClose");
		if(azumio.lastOpenWindowCloseCallback){
			azumio.lastOpenWindowCloseCallback();
		}
	}

	this.showProgressOverlay = function(onOff){
		if(onOff && !document.getElementById("progressOverlay")){
			$("body").append("<div id='progressOverlay'></div>");
		}
		
		if(onOff){
			$("#progressOverlay").show(500);
		}else{
			$("#progressOverlay").hide(500);
		}
	}
	
	this.cachedCheckins = [];
	this.getCheckins = function(callback,filters,onError){
		azumio.jsonGet("/v1/checkins",{
			success:function(data){
				var ci = data.checkins;
				callback(ci,data.hasMore);
			},
			error:function(){
				//return cached + localqueue
				if(onError){
					onError(returnCached);
				}
			},
			data:filters
		});
	}
	
	this.getUncommitedCheckins = function(callback){
			callback(azumio.queue.all());
	}
	
	this.addCheckin = function(checkin){
		//add checkin to queue and later sync it in bg
		this.queue.push(checkin);
	}
	
	this.deleteCheckin = function(id,obj){
		azumio.jsonDelete("/v1/checkins/"+id, obj );
	}
	
	this.addToCache=function(obj,name){
		localStorage["cache."+name] = JSON.stringify(obj);
		localStorage["cache."+name+".modified"] = new Date().getTime();
	} 
	
	this.getFromCache = function(name,def){
		try{
			var jsonString = localStorage["cache."+name];
			if(jsonString){
				return JSON.parse(localStorage["cache."+name]);
			}else{
				return def;
			}
		}catch(e){
			azumio.logError(e);
		}
	}
	
	//geoloc
	this.loginHandlers = [];
	this.loggendIn = false;
	this.onLogin = function(handler){
		azumio.logInfo("onLogin");
		if(handler){
			azumio.loginHandlers.push(handler);
		}else{
			azumio.logDebug("Logged in");
			for(var i=0;i < azumio.loginHandlers.length;i++){
				azumio.loginHandlers[i]();
			}
		}
		azumio.sync();
	}
	
	this.getLocation = function(){
		if(azumio.hasWebViewBoost){
			window.location = "azumio:locationServicesOn:";
		}else if (navigator.geolocation) {
			  navigator.geolocation.getCurrentPosition(onLocationChangeHtml5, error);
		} else {
			azumio.logInfo('Location services not supported');
		}
	}
	
	this.locationServicesOff = function(){
		if(azumio.hasWebViewBoost){
			window.location = "azumio:locationServicesOff:";
		}
	}
	
	this.onLocationChange = function(lat,long,accur){
		azumio.geoloc = "geo:"+lat+","+long+";u="+accur;
		azumio.logInfo("location " + azumio.geoloc);
	}

	this.geoloc = false;
	function onLocationChangeHtml5(pos) {
		geoloc = "geo:"+pos.coords.latitude+","+pos.coords.longitude+";u="+pos.coords.accuracy;
	}
	
	this.tempFile = null;
	
	this.setTempFile = function(name,file){
		//azumio.logDebug("Temp file " + name);
		//alert("Temp file2 " + name);
		//There is a bug in stress check code that generates 100k zeros at the beggining.
		//this shows as AAA in the base64 encoding.
		//detect that and get rid of it.
		
		//alert(file.substring((100000-10)*3/2,3));
	
		//alert(file.length);
		if(file.substring(0,3)=="AAA"){
			//alert("Looks like a problematic file");
			//decode
			try{
			var raw = atob(file);
			//alert(raw.length);
			//alert(raw.length*4/3 - file.length);
			raw = raw.substring(100000);
			file = btoa(raw);
			}catch(e){
				//alert("e");
			}
		}else{
			//alert("Looks like a good file");
		}
		//alert(file.length);
		//alert(file);
		azumio.tempFile = {};
		azumio.tempFile.name = name;
		azumio.tempFile.file = file;
	}
	

	
	function error(car){
	}
	
	this.logError = function(a){
			try{
			
			//window.location="log:Error:"+encodeURI(a);
			
		}catch(e){};
	}
	
	this.logInfo = function(a){
		try{
			//window.location="log:Info:"+encodeURI(a);
		}catch(e){};
	}
	
	this.logDebug = function(a){
		//alert("Debug: " + a);
		try{
			//window.location="log:Debug:"+encodeURI(a);
		}catch(e){};
	}

	
	//checkin sync
	//sync checkins in queue
	this.sync = function(){
		azumio.onSyncStart();
		azumio.syncWorker();
	}
	
	this.syncWorker = function(){
		azumio.logDebug("syncWorker()");
		var checkin = this.queue.peek();
		if(!checkin){
			azumio.onSyncComplete();
			return;
		}
		azumio.logDebug("syncWorker() jsonCall");
		
		this.jsonPost("/v1/checkins", {
			success:function(){
				azumio.queue.removeTail();
				//azumio.logDebug("good");
				azumio.syncWorker();
			},
			error:function(obj){
				if( obj.meta.code == 409 ){
					//duplicate
					//alert("duplicate")
					azumio.queue.removeTail();
					azumio.syncWorker();
				}else{
					//alert(obj.meta.code);
					azumio.logDebug(obj.meta.msg);
				}
			},
			data:{
				"json":JSON.stringify(checkin,null," ")
			}
		});
	}
	
	this.onSyncStart = function(){
		azumio.setCheckinButtonState("working");
	}
	
	this.onSyncComplete = function(){
		azumio.setCheckinButtonState("complete");
	}
	
	this.setCheckinButtonState = function(stateClass){
		$("button.checkinLuncher").removeClass("idle");
		$("button.checkinLuncher").removeClass("working");
		$("button.checkinLuncher").removeClass("complete");
		$("button.checkinLuncher").addClass(stateClass);
	}
	
	//checkin queue
	function Queue(){
		if(!localStorage["head"] || !localStorage['tail'] ){
			localStorage["head"] = localStorage["tail"] = 0;
		}
		
		this.head = function(){
			return parseInt(localStorage["head"]);
		}
		
		this.tail = function(){
			return parseInt(localStorage["tail"]);
		}
		
		this.push = function(obj){
			var h = this.head();
			localStorage["queue."+h] = JSON.stringify(obj,null," ");
			localStorage["head"] = h+1;
		}
		
		this.peek = function(){
			var t = this.tail();
			var h = this.head();
			if(t>=h)
				return null;
			var cis = localStorage["queue."+t];
			var ci = JSON.parse(cis);
			return ci;
		}
		this.removeTail = function(){
			var t = this.tail();
			var h = this.head();
			if(t>=h)
				return false;
			t = t + 1;
			localStorage["tail"] = t;
		}
		
		this.pop = function(){
			var ci = this.peek();
			this.removeTail();
			return ci;
		}
		
		this.all = function(){
			var h = this.head();
			var t = this.tail();
			var q = [];
			while(t<h){
				var key = "queue."+(h-1);
				var cis = localStorage.getItem(key);
				var checkin = JSON.parse(cis)
				q.push( checkin );
				h = h-1;
			}
			return q;
		} 
		return this;
	}
	
	this.queue = Queue();
	
	//browser detection
	this.isIPhoneSafari = function(){
		var isSafari = navigator.userAgent.match(/Safari/i) != null;
		var isIPhone =  navigator.userAgent.match(/iPhone/i) != null;
		return isSafari && isIPhone;
	}
	
	this.isIPhoneUIWebView = function(){
		var isSafari = navigator.userAgent.match(/Safari/i) != null;
		var isIPhone =  navigator.userAgent.match(/iPhone/i) != null;
		return !isSafari && isIPhone;
	}
	
	this.isAndroidWebView = function(){
		return navigator.userAgent.match(/AzumioWebView/i) != null;
	}
	
	
	try{
		if(this.isIPhoneUIWebView()){
			window.location="azumio:ping:....";
		}
	}catch(e){}
	
	return this;
}

$(function(){
	window.azumio = Azumio(window);
})

//Hash search
var HashSearch = new function () {
       var params;

       this.set = function (key, value) {
          params[key] = value;
          this.push();
       };

       this.get = function (key, value) {
           return params[key];
       };

       this.keyExists = function (key) {
           return params.hasOwnProperty(key);
       };

       this.push= function () {
           var hashBuilder = [], key, value;

           for(key in params) if (params.hasOwnProperty(key)) {
               key = escape(key), value = escape(params[key]); // escape(undefined) == "undefined"
               hashBuilder.push(key + ( (value !== "undefined") ? '=' + value : "" ));
           }

           window.location.hash = hashBuilder.join("&");
       };

       (this.load = function () {
           params = {}
           var hashStr = window.location.hash, hashArray, keyVal
           hashStr = hashStr.substring(1, hashStr.length);
           hashArray = hashStr.split('&');

           for(var i = 0; i < hashArray.length; i++) {
               keyVal = hashArray[i].split('=');
               params[unescape(keyVal[0])] = (typeof keyVal[1] != "undefined") ? unescape(keyVal[1]) : keyVal[1];
           }
       })();
    }


/*
 * Date Format 1.2.3
 * (c) 2007-2009 Steven Levithan <stevenlevithan.com>
 * MIT license
 *
 * Includes enhancements by Scott Trenda <scott.trenda.net>
 * and Kris Kowal <cixar.com/~kris.kowal/>
 *
 * Accepts a date, a mask, or a date and a mask.
 * Returns a formatted version of the given date.
 * The date defaults to the current date/time.
 * The mask defaults to dateFormat.masks.default.
 */

var dateFormat = function () {
	var	token = /d{1,4}|m{1,4}|yy(?:yy)?|([HhMsTt])\1?|[LloSZ]|"[^"]*"|'[^']*'/g,
		timezone = /\b(?:[PMCEA][SDP]T|(?:Pacific|Mountain|Central|Eastern|Atlantic) (?:Standard|Daylight|Prevailing) Time|(?:GMT|UTC)(?:[-+]\d{4})?)\b/g,
		timezoneClip = /[^-+\dA-Z]/g,
		pad = function (val, len) {
			val = String(val);
			len = len || 2;
			while (val.length < len) val = "0" + val;
			return val;
		};

	// Regexes and supporting functions are cached through closure
	return function (date, mask, utc) {
		var dF = dateFormat;

		// You can't provide utc if you skip other args (use the "UTC:" mask prefix)
		if (arguments.length == 1 && Object.prototype.toString.call(date) == "[object String]" && !/\d/.test(date)) {
			mask = date;
			date = undefined;
		}

		// Passing date through Date applies Date.parse, if necessary
		date = date ? new Date(date) : new Date;
		if (isNaN(date)) throw SyntaxError("invalid date");

		mask = String(dF.masks[mask] || mask || dF.masks["default"]);

		// Allow setting the utc argument via the mask
		if (mask.slice(0, 4) == "UTC:") {
			mask = mask.slice(4);
			utc = true;
		}

		var	_ = utc ? "getUTC" : "get",
			d = date[_ + "Date"](),
			D = date[_ + "Day"](),
			m = date[_ + "Month"](),
			y = date[_ + "FullYear"](),
			H = date[_ + "Hours"](),
			M = date[_ + "Minutes"](),
			s = date[_ + "Seconds"](),
			L = date[_ + "Milliseconds"](),
			o = utc ? 0 : date.getTimezoneOffset(),
			flags = {
				d:    d,
				dd:   pad(d),
				ddd:  dF.i18n.dayNames[D],
				dddd: dF.i18n.dayNames[D + 7],
				m:    m + 1,
				mm:   pad(m + 1),
				mmm:  dF.i18n.monthNames[m],
				mmmm: dF.i18n.monthNames[m + 12],
				yy:   String(y).slice(2),
				yyyy: y,
				h:    H % 12 || 12,
				hh:   pad(H % 12 || 12),
				H:    H,
				HH:   pad(H),
				M:    M,
				MM:   pad(M),
				s:    s,
				ss:   pad(s),
				l:    pad(L, 3),
				L:    pad(L > 99 ? Math.round(L / 10) : L),
				t:    H < 12 ? "a"  : "p",
				tt:   H < 12 ? "am" : "pm",
				T:    H < 12 ? "A"  : "P",
				TT:   H < 12 ? "AM" : "PM",
				Z:    utc ? "UTC" : (String(date).match(timezone) || [""]).pop().replace(timezoneClip, ""),
				o:    (o > 0 ? "-" : "+") + pad(Math.floor(Math.abs(o) / 60) * 100 + Math.abs(o) % 60, 4),
				S:    ["th", "st", "nd", "rd"][d % 10 > 3 ? 0 : (d % 100 - d % 10 != 10) * d % 10]
			};

		return mask.replace(token, function ($0) {
			return $0 in flags ? flags[$0] : $0.slice(1, $0.length - 1);
		});
	};
}();

// Some common format strings
dateFormat.masks = {
	"default":      "ddd mmm dd yyyy HH:MM:ss",
	shortDate:      "m/d/yy",
	mediumDate:     "mmm d, yyyy",
	longDate:       "mmmm d, yyyy",
	fullDate:       "dddd, mmmm d, yyyy",
	shortTime:      "h:MM TT",
	mediumTime:     "h:MM:ss TT",
	longTime:       "h:MM:ss TT Z",
	isoDate:        "yyyy-mm-dd",
	isoTime:        "HH:MM:ss",
	isoDateTime:    "yyyy-mm-dd'T'HH:MM:ss",
	isoUtcDateTime: "UTC:yyyy-mm-dd'T'HH:MM:ss'Z'"
};

// Internationalization strings
dateFormat.i18n = {
	dayNames: [
		"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat",
		"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"
	],
	monthNames: [
		"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec",
		"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"
	]
};

// For convenience...
Date.prototype.format = function (mask, utc) {
	return dateFormat(this, mask, utc);
};
