/**
 * 
 */

$(function(){
	window.azumio.register = {};
	
	
	window.azumio.register.switchPage = function(page){
		var newpage = $("."+page);
		$(".visible").get(0).style["-webkit-animation"]="hideIt 0.6s";
		newpage.get(0).style["-webkit-animation"]="showIt 0.6s";
		
		$(".bubble").removeClass("visible");
		newpage.addClass("visible");
		var wh = $(window).height();
		var bh = newpage.height();
		
		newpage.css("margin-top",((wh-bh)*0.4) + "px");
	};
	
	azumio.register.refitBubble = function(bubble){
		var wh = $(window).height();
		var bh = $(bubble).height();
		$(bubble).css("margin-top",((wh-bh)*0.4) + "px");
	};
	

	
	
	
	$(".close-button").click(function(){
		azumio.register.showIntroOrClose();
	});
	
	$(".close-button.intro, #startUsing").click(function(){
		azumio.register.close();
	});
	
	$("button.doItLater").click(function(){
		azumio.trackEvent("register.doItLater");
		azumio.register.doItLater();
	});
	
	
	$("button").click(function(){
		var t = $(this);
		var page = t.attr("page");
		if(!page)
			return;
		page = "page"+page;
		
		window.azumio.register.switchPage(page);
	});
	
});

$(function() {
	
	$(window).bind("azumio.auth.requestLogin",function(){
		azumio.trackEvent("register.requestLogin");
		window.azumio.register.showOverlay();
	});
	
	$(".twitter").click(function() {
		azumio.trackEvent("register.twitterLoginStart");
		azumio.openWindow(azumio.settings.apidomain + "/auth/thirdparty?method=twitter");
	});

	$(".facebook").click(function() {
		azumio.trackEvent("register.facebookLoginStart");
		azumio.openWindow(azumio.settings.apidomain + "/auth/thirdparty?method=facebook");
	});
	
	$(".facebookSDK").click(function() {
		azumio.trackEvent("register.facebookLoginStart");
		azumio.exec("azumio:facebook:requestToken:");
	});
	
	$("button.email").click(function() {
		azumio.trackEvent("register.emailLoginStart");
		azumio.register.switchPage("pageemail");
	});
	
	var showLoading = function(onOff){
		if( onOff ){
			$(".logo").addClass("loading");
		}else{
			$(".logo").removeClass("loading");
		}
	}

	$(window).bind('azumio.window.return', function(a, b) {
		//alert("a.b");
		
		if (b.meta.code != 200) {
			return;
		}
		
		azumio.trackEvent("register.twitterLoginComplete");
		
		var req = {};
		req.data = {};
		req.data.grant_type = "client_credentials";

		req.success = function(data) {
			azumio.register.showIntroOrClose();
		};

		req.error = function(reason) {
			alert("Error connection to you Twitter account. Please try again.");
		};

		req.complete = function() {
			showLoading(false);
		}

		if (b.twitter) {
			//alert("Twitter");
			req.data.twitter = JSON.stringify(b.twitter);
		}

		if (b.facebook) {
			//alert("Facebook");
			req.data.facebook = JSON.stringify(b.facebook);
		}

		//alert("will load");
		azumio.auth.requestOAuthToken(req);
		showLoading(true);
	});
	
	$(window).bind('azumio.facebook.token', function(a, b) {
		azumio.trackEvent("register.facebookLoginComplete");
		
		setTimeout(function(){
			//alert(JSON.stringify(b));
			
			var req = {};
			req.data = {};
			req.data.grant_type = "client_credentials";

			req.success = function(data) {
				azumio.register.showIntroOrClose();
			};

			req.error = function(reason) {
				alert("Error connection to you Facebook account. Please try again.");
			};

			req.complete = function() {
				showLoading(false);
			}

			
			req.data.facebook = JSON.stringify(b.facebook);
			

			//alert("will load");
			azumio.auth.requestOAuthToken(req);
			showLoading(true);
		},1);
		
	});

	window.azumio.register.showOverlay = function() {
		azumio.trackEvent("register.showOverlay");
		
		window.azumio.register.switchPage("page2");
		setTimeout(function() {
			azumio.register.refitBubble($(".visible"));
			azumio.exec("azumio:show:");
		}, 1);
		
		localStorage["page.register.lastDisplayed"] = new Date().getTime(); 
	}
	
	azumio.register.showIntroOrClose = function(){
		if(! localStorage["register.introDisplayed"] ){
			localStorage["register.introDisplayed"] = true;
			azumio.register.switchPage("pageintro");
			azumio.register.refitBubble($(".visible"));
			azumio.exec("azumio:show:");
		}else{
			azumio.register.close();
		}
	};
	
	azumio.register.close = function(){
		azumio.exec("azumio:closeWindow:");
	};
	
	window.azumio.register.onLaunch = function(){

		var authenticated = azumio.auth.isAuthenticated();
		var overlayLastDisplayed = parseInt(localStorage["page.register.lastDisplayed"] || 0);
		var sinceLastDisplay = new Date().getTime() - overlayLastDisplayed;
		var minOverlayTimeBetweenShow = 20*60*1000;

		if( !authenticated  && sinceLastDisplay > minOverlayTimeBetweenShow ){
			if( Math.random() < 0.3){//show it to half of the users
				azumio.trackEvent("register.startupOverlayDisplayed");
				window.azumio.register.showOverlay();
			}else{
				azumio.trackEvent("register.startupOverlayNOTDisplayed");
				azumio.register.showIntroOrClose();
			}
			
		}
	}

	$(window).bind("azumio.appreturnfrombackground", function() {
		window.azumio.register.onLaunch(); 
	});

	window.azumio.register.onLaunch();


	
	azumio.register.doItLater = function(){
		azumio.register.showIntroOrClose();
	}
	
	
	//email handling
	
	var checkEmail = function(){
		
		var email = $("#email").val();
		
		$("#email").addClass("loading");
		$("#passwordError").html("");
		
		azumio.jsonGet("/v1/utils", {
			data : {
				emailExists : email
			},
			
			success:function(json){
				$("#emailError").html("");
				if(json.exists){
					$("#emailStatus").html("Existing user! Enter your password");
					$("#password").show().attr("placeholder","Password");
					$("#password2").hide();
				}else{
					$("#emailStatus").html("New user! Choose new password.");
					$("#password,#password2").show();
					$("#password").attr("placeholder","New Password");
				}
				$("button#register").show();
				$("button#checkEmail").hide();
				
				$("#emailError").html("");
			},
			error:function(e){
				$("#emailStatus").html("");
				$("#password,#password2").hide();
				$("#emailError").html(e.meta.errorDetail);
				$("button#register").hide();
				$("button#checkEmail").show();
			},
			complete:function(){
				$("#email").removeClass("loading");
				azumio.register.refitBubble($(".pageemail"));
			}
		});
	};

	$("input.email").bind("focusout",checkEmail);
	$("button#checkEmail").bind("click",checkEmail);
	
	var checkPassword = function() {
			var req = {};
			req.data = {};
			req.data.grant_type = "password";
			req.data.email = $("#email").val();
			req.data.password = $("#password").val();
			req.data.password2 = $("#password2").val();

			req.success = function(data) {
				$("#passwordError").html("");
				//alert("ok " + JSON.stringify(data));
				azumio.trackEvent("register.emailLoginComplete");
				azumio.register.showIntroOrClose();
			};

			req.error = function(reason) {
				$("#passwordError").html(reason.meta.errorDetail);
				//$.mobile.hidePageLoadingMsg();
			};

			req.complete = function() {
				//$.mobile.hidePageLoadingMsg();
				$("#password,#password2").removeClass("loading");
				azumio.register.refitBubble($(".pageemail"));
			}

			$("#password,#password2").addClass("loading");
			azumio.auth.requestOAuthToken(req);

		};
		
		$("button#register").click(checkPassword);
		$("#password").bind("focusout",function(){
			if(!$("#password2").is(":visible")){
				checkPassword();
			}
		});
		
		$("#password2").bind("focusout",function(){
			checkPassword();
		});
	

	
});
